--
-- MySQL 5.0.67
-- Sun, 20 Dec 2009 17:08:59 +0000
--

CREATE TABLE `custom_field_type` (
   `id` int(11) unsigned not null auto_increment,
   `field_type` varchar(45),
   `ts` timestamp not null default CURRENT_TIMESTAMP,
   PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1;

-- [Table `custom_field_type` is empty]

CREATE TABLE `lab_config` (
   `lab_config_id` int(10) unsigned not null auto_increment,
   `name` varchar(45) not null,
   `location` varchar(45) not null,
   `admin_user_id` int(10) unsigned not null,
   `db_name` varchar(45),
   PRIMARY KEY (`lab_config_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1;

-- [Table `lab_config` is empty]

CREATE TABLE `lab_config_specimen_type` (
   `lab_config_id` int(10) unsigned not null,
   `specimen_type_id` int(10) unsigned not null
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- [Table `lab_config_specimen_type` is empty]

CREATE TABLE `lab_config_test_type` (
   `lab_config_id` int(10) unsigned not null,
   `test_type_id` int(10) unsigned not null
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- [Table `lab_config_test_type` is empty]

CREATE TABLE `measure` (
   `measure_id` int(11) unsigned not null auto_increment,
   `name` varchar(45) not null,
   `unit_id` int(10) unsigned,
   `range` varchar(45) not null,
   `description` varchar(100),
   `ts` timestamp not null default CURRENT_TIMESTAMP,
   `unit` varchar(30),
   PRIMARY KEY (`measure_id`),
   KEY `unit_id` (`unit_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1;

-- [Table `measure` is empty]

CREATE TABLE `patient` (
   `patient_id` int(11) unsigned not null,
   `addl_id` varchar(40),
   `name` varchar(45),
   `sex` char(1) not null,
   `age` decimal(10,0),
   `dob` date,
   `created_by` int(11) unsigned,
   `ts` timestamp not null default CURRENT_TIMESTAMP,
   PRIMARY KEY (`patient_id`),
   KEY `created_by` (`created_by`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

INSERT INTO `patient` (`patient_id`, `addl_id`, `name`, `sex`, `age`, `dob`, `created_by`, `ts`) VALUES 
('100', '', 'Jack Serrano', 'M', '', '2001-09-20', '', '2009-12-17 01:07:47'),
('101', '', 'Carter Beasley', 'M', '', '2002-04-01', '', '2009-12-17 01:07:47'),
('102', '', 'Valentine Brooks', 'M', '', '1993-01-21', '', '2009-12-17 01:07:47'),
('103', '', 'Burton Sloan', 'M', '', '1981-10-28', '', '2009-12-17 01:07:47'),
('104', '', 'Zane Blevins', 'M', '', '1974-08-12', '', '2009-12-17 01:07:47'),
('105', '', 'Wylie Fry', 'M', '', '1984-11-16', '', '2009-12-17 01:07:47'),
('106', '', 'Daquan Edwards', 'M', '', '1976-04-11', '', '2009-12-17 01:07:47'),
('107', '', 'Jacob Dennis', 'M', '', '1971-12-21', '', '2009-12-17 01:07:47'),
('108', '', 'Harding Barry', 'M', '', '1980-03-20', '', '2009-12-17 01:07:48'),
('109', '', 'Garrison Hewitt', 'M', '', '2007-01-19', '', '2009-12-17 01:07:48'),
('110', '', 'Ivan Sexton', 'M', '', '1973-08-14', '', '2009-12-17 01:07:48'),
('111', '', 'Donovan Bell', 'M', '', '1990-02-04', '', '2009-12-17 01:07:48'),
('112', '', 'Dustin Sanford', 'M', '', '1980-09-17', '', '2009-12-17 01:07:48'),
('113', '', 'Isaiah Alford', 'M', '', '2006-08-15', '', '2009-12-17 01:07:48'),
('114', '', 'Basil Perry', 'M', '', '1986-08-25', '', '2009-12-17 01:07:48'),
('115', '', 'Christian Mcconnell', 'M', '', '1999-09-16', '', '2009-12-17 01:07:48'),
('116', '', 'Justin Hanson', 'M', '', '1972-11-01', '', '2009-12-17 01:07:48'),
('117', '', 'Lucas Joyner', 'M', '', '1986-07-01', '', '2009-12-17 01:07:48'),
('118', '', 'Ivan Rollins', 'M', '', '1976-04-09', '', '2009-12-17 01:07:48'),
('119', '', 'Erasmus Joseph', 'M', '', '1983-04-29', '', '2009-12-17 01:07:48'),
('120', '', 'Steven Frank', 'M', '', '2007-12-11', '', '2009-12-17 01:07:48'),
('121', '', 'Randall Caldwell', 'M', '', '1983-01-22', '', '2009-12-17 01:07:48'),
('122', '', 'Keefe Floyd', 'M', '', '1994-08-16', '', '2009-12-17 01:07:48'),
('123', '', 'Fritz Acosta', 'M', '', '1980-08-27', '', '2009-12-17 01:07:48'),
('124', '', 'Erich Reese', 'M', '', '2002-04-24', '', '2009-12-17 01:07:48'),
('125', '', 'Hakeem Shaffer', 'M', '', '1990-06-29', '', '2009-12-17 01:07:48'),
('126', '', 'Kermit Perez', 'M', '', '2001-12-27', '', '2009-12-17 01:07:48'),
('127', '', 'Thaddeus Terry', 'M', '', '2008-02-28', '', '2009-12-17 01:07:48'),
('128', '128', 'John Hall', 'M', '', '1976-12-13', '', '2009-12-17 01:07:48'),
('129', '', 'Tobias Meyer', 'M', '', '1987-11-14', '', '2009-12-17 01:07:48'),
('130', '', 'Benedict Bryant', 'M', '', '1971-07-12', '', '2009-12-17 01:07:48'),
('131', '', 'Ciaran Morton', 'M', '', '1979-12-20', '', '2009-12-17 01:07:48'),
('132', '', 'Jackson Sims', 'M', '', '1991-03-10', '', '2009-12-17 01:07:48'),
('133', '', 'Brett Wood', 'M', '', '1982-06-25', '', '2009-12-17 01:07:48'),
('134', '', 'Logan James', 'M', '', '1974-06-06', '', '2009-12-17 01:07:48'),
('135', '', 'Hoyt Kline', 'M', '', '1998-11-18', '', '2009-12-17 01:07:48'),
('136', '', 'Price Ellis', 'M', '', '2005-12-02', '', '2009-12-17 01:07:48'),
('137', '', 'Louis Gonzales', 'M', '', '1991-04-08', '', '2009-12-17 01:07:48'),
('138', '', 'Kasimir Alexander', 'M', '', '1985-01-26', '', '2009-12-17 01:07:48'),
('139', '', 'Felix Townsend', 'M', '', '1990-03-05', '', '2009-12-17 01:07:48'),
('140', '', 'Phelan Riley', 'M', '', '1986-03-14', '', '2009-12-17 01:07:48'),
('141', '', 'Oliver Goodman', 'M', '', '1984-08-27', '', '2009-12-17 01:07:48'),
('142', '', 'Ivan Miller', 'M', '', '2000-10-08', '', '2009-12-17 01:07:48'),
('143', '', 'Dale Atkins', 'M', '', '2001-02-12', '', '2009-12-17 01:07:48'),
('144', '', 'Abdul Cash', 'M', '', '1970-09-21', '', '2009-12-17 01:07:48'),
('145', '', 'Lucius Bright', 'M', '', '2000-11-18', '', '2009-12-17 01:07:48'),
('146', '', 'David Sloan', 'M', '', '1995-06-17', '', '2009-12-17 01:07:48'),
('147', '', 'Owen Reynolds', 'M', '', '1992-06-03', '', '2009-12-17 01:07:48'),
('148', '', 'Nash Sullivan', 'M', '', '2005-07-26', '', '2009-12-17 01:07:48'),
('149', '', 'Oscar Gilbert', 'M', '', '1999-08-28', '', '2009-12-17 01:07:48'),
('150', '', 'Ferris Cummings', 'M', '', '1985-04-04', '', '2009-12-17 01:07:48'),
('151', '', 'Samuel Caldwell', 'M', '', '1976-01-08', '', '2009-12-17 01:07:48'),
('152', '', 'Igor Joyce', 'M', '', '1994-10-14', '', '2009-12-17 01:07:48'),
('153', '', 'Ira Barrett', 'M', '', '1982-04-25', '', '2009-12-17 01:07:48'),
('154', '', 'Ivor Shaffer', 'M', '', '1999-03-27', '', '2009-12-17 01:07:48'),
('155', '', 'Wade Dunlap', 'M', '', '1985-03-11', '', '2009-12-17 01:07:48'),
('156', '', 'Lamar Odonnell', 'M', '', '2000-02-23', '', '2009-12-17 01:07:48'),
('157', '', 'Lane Bradley', 'M', '', '1974-08-11', '', '2009-12-17 01:07:48'),
('158', '', 'Dustin Solomon', 'M', '', '1991-04-01', '', '2009-12-17 01:07:48'),
('159', '', 'Boris Fry', 'M', '', '1987-07-03', '', '2009-12-17 01:07:48'),
('160', '', 'Addison Reilly', 'M', '', '1984-07-27', '', '2009-12-17 01:07:48'),
('161', '', 'Guy Ferguson', 'M', '', '1975-04-13', '', '2009-12-17 01:07:48'),
('162', '', 'Lars Chen', 'M', '', '2003-11-28', '', '2009-12-17 01:07:48'),
('163', '', 'Amal Freeman', 'M', '', '1971-02-20', '', '2009-12-17 01:07:48'),
('164', '', 'Andrew Roman', 'M', '', '1974-11-19', '', '2009-12-17 01:07:48'),
('165', '', 'Macaulay Hendricks', 'M', '', '1986-10-29', '', '2009-12-17 01:07:48'),
('166', '', 'Abdul Kennedy', 'M', '', '1978-05-31', '', '2009-12-17 01:07:48'),
('167', '', 'Joseph Juarez', 'M', '', '1988-12-19', '', '2009-12-17 01:07:48'),
('168', '', 'Yardley Atkins', 'M', '', '1985-02-21', '', '2009-12-17 01:07:48'),
('169', '', 'Jin James', 'M', '', '1975-11-22', '', '2009-12-17 01:07:48'),
('170', '', 'Seth Jennings', 'M', '', '2005-08-12', '', '2009-12-17 01:07:48'),
('171', '', 'Norman Humphrey', 'M', '', '1972-01-10', '', '2009-12-17 01:07:48'),
('172', '', 'Caesar Gilbert', 'M', '', '1995-10-13', '', '2009-12-17 01:07:48'),
('173', '', 'Kadeem Irwin', 'M', '', '1983-08-21', '', '2009-12-17 01:07:48'),
('174', '', 'Charles Nicholson', 'M', '', '2006-07-06', '', '2009-12-17 01:07:48'),
('175', '', 'Quentin Crosby', 'M', '', '1998-08-19', '', '2009-12-17 01:07:48'),
('176', '', 'Hammett Cooley', 'M', '', '1972-10-31', '', '2009-12-17 01:07:48'),
('177', '', 'Jack Barnett', 'M', '', '1995-07-31', '', '2009-12-17 01:07:48'),
('178', '', 'Fritz Little', 'M', '', '1996-05-04', '', '2009-12-17 01:07:48'),
('179', '', 'Felix Hill', 'M', '', '1984-12-11', '', '2009-12-17 01:07:48'),
('180', '', 'Elvis Acosta', 'M', '', '1976-01-26', '', '2009-12-17 01:07:48'),
('181', '', 'Roth Gentry', 'M', '', '1977-02-01', '', '2009-12-17 01:07:48'),
('182', '', 'Jackson Guthrie', 'M', '', '2001-05-16', '', '2009-12-17 01:07:48'),
('183', '', 'Robert Jensen', 'M', '', '1973-06-12', '', '2009-12-17 01:07:48'),
('184', '', 'Gavin Golden', 'M', '', '1981-06-18', '', '2009-12-17 01:07:48'),
('185', '', 'Vladimir Donovan', 'M', '', '2001-01-27', '', '2009-12-17 01:07:48'),
('186', '', 'Rogan Nolan', 'M', '', '1972-06-25', '', '2009-12-17 01:07:48'),
('187', '', 'Nathan Wilson', 'M', '', '1988-07-20', '', '2009-12-17 01:07:48'),
('188', '', 'Acton Dunn', 'M', '', '1998-10-15', '', '2009-12-17 01:07:48'),
('189', '', 'Hector Craig', 'M', '', '1982-07-20', '', '2009-12-17 01:07:48'),
('190', '', 'Ulysses Dawson', 'M', '', '2007-11-15', '', '2009-12-17 01:07:48'),
('191', '', 'Hakeem Goodwin', 'M', '', '1988-02-05', '', '2009-12-17 01:07:48'),
('192', '', 'Hammett Valdez', 'M', '', '1993-11-25', '', '2009-12-17 01:07:48'),
('193', '', 'Gavin Roth', 'M', '', '1980-11-04', '', '2009-12-17 01:07:48'),
('194', '', 'Henry Pugh', 'M', '', '1985-08-17', '', '2009-12-17 01:07:48'),
('195', '', 'Cody Roberts', 'M', '', '1988-12-11', '', '2009-12-17 01:07:48'),
('196', '', 'Oscar Battle', 'M', '', '2008-12-16', '', '2009-12-17 01:07:48'),
('197', '', 'Boris Dodson', 'M', '', '1981-11-01', '', '2009-12-17 01:07:48'),
('198', '', 'Hakeem Wagner', 'M', '', '1988-09-24', '', '2009-12-17 01:07:48'),
('199', '', 'Nigel Sanchez', 'M', '', '1976-05-11', '', '2009-12-17 01:07:48'),
('200', '', 'Dennis Newton', 'M', '', '1980-11-13', '', '2009-12-17 01:07:48'),
('201', '', 'Arden Briggs', 'M', '', '1983-05-21', '', '2009-12-17 01:07:48'),
('202', '', 'Erasmus Rice', 'M', '', '1995-11-22', '', '2009-12-17 01:07:48'),
('203', '', 'Axel Gomez', 'M', '', '1982-08-29', '', '2009-12-17 01:07:48'),
('204', '', 'Akeem Leach', 'M', '', '1980-01-26', '', '2009-12-17 01:07:48'),
('205', '', 'Kareem Waters', 'M', '', '1998-05-04', '', '2009-12-17 01:07:48'),
('206', '', 'Palmer Williamson', 'M', '', '2006-08-24', '', '2009-12-17 01:07:48'),
('207', '', 'Drake Cline', 'M', '', '1988-03-28', '', '2009-12-17 01:07:48'),
('208', '', 'Tate Owen', 'M', '', '1977-08-31', '', '2009-12-17 01:07:48'),
('209', '', 'Yardley Gilliam', 'M', '', '1979-08-15', '', '2009-12-17 01:07:48'),
('210', '', 'Hasad Cook', 'M', '', '2007-11-29', '', '2009-12-17 01:07:48'),
('211', '', 'Brandon Cole', 'M', '', '2006-02-07', '', '2009-12-17 01:07:48'),
('212', '', 'Cyrus Deleon', 'M', '', '2008-12-30', '', '2009-12-17 01:07:48'),
('213', '', 'Harding Nielsen', 'M', '', '1982-04-09', '', '2009-12-17 01:07:48'),
('214', '', 'Calvin Carrillo', 'M', '', '1987-11-01', '', '2009-12-17 01:07:48'),
('215', '', 'Igor Houston', 'M', '', '1992-09-14', '', '2009-12-17 01:07:48'),
('216', '', 'Reese Livingston', 'M', '', '1974-05-17', '', '2009-12-17 01:07:48'),
('217', '', 'Justin Carson', 'M', '', '1973-10-04', '', '2009-12-17 01:07:48'),
('218', '', 'Drew Mitchell', 'M', '', '2001-08-24', '', '2009-12-17 01:07:48'),
('219', '', 'Jakeem Gamble', 'M', '', '1987-08-07', '', '2009-12-17 01:07:48'),
('220', '', 'Caesar Beck', 'M', '', '1970-12-02', '', '2009-12-17 01:07:48'),
('221', '', 'Deacon Tyler', 'M', '', '1976-02-12', '', '2009-12-17 01:07:48'),
('222', '', 'Alexander May', 'M', '', '2000-07-23', '', '2009-12-17 01:07:48'),
('223', '', 'Baxter Vega', 'M', '', '2000-06-04', '', '2009-12-17 01:07:48'),
('224', '', 'David Bird', 'M', '', '1991-08-25', '', '2009-12-17 01:07:48'),
('225', '', 'Darius Patel', 'M', '', '2008-06-11', '', '2009-12-17 01:07:48'),
('226', '', 'Davis Hardy', 'M', '', '1995-01-12', '', '2009-12-17 01:07:48'),
('227', '', 'Thane Lane', 'M', '', '1978-06-03', '', '2009-12-17 01:07:48'),
('228', '', 'Leroy Galloway', 'M', '', '1970-12-29', '', '2009-12-17 01:07:48'),
('229', '', 'Chadwick Roman', 'M', '', '1972-08-14', '', '2009-12-17 01:07:48'),
('230', '', 'Hunter Nguyen', 'M', '', '1976-12-31', '', '2009-12-17 01:07:48'),
('231', '', 'Cooper Figueroa', 'M', '', '1995-05-09', '', '2009-12-17 01:07:48'),
('232', '', 'Christian Rogers', 'M', '', '2002-11-29', '', '2009-12-17 01:07:48'),
('233', '', 'Harrison Kline', 'M', '', '1977-12-30', '', '2009-12-17 01:07:48'),
('234', '', 'Guy Wallace', 'M', '', '1996-09-27', '', '2009-12-17 01:07:48'),
('235', '', 'Roth Mayer', 'M', '', '1993-10-08', '', '2009-12-17 01:07:48'),
('236', '', 'Zane Bright', 'M', '', '2003-05-20', '', '2009-12-17 01:07:48'),
('237', '', 'Isaac Ayala', 'M', '', '2006-12-17', '', '2009-12-17 01:07:48'),
('238', '', 'Matthew Mayo', 'M', '', '1973-06-07', '', '2009-12-17 01:07:48'),
('239', '', 'Wallace Warner', 'M', '', '1993-08-31', '', '2009-12-17 01:07:48'),
('240', '', 'Luke Curry', 'M', '', '1991-09-03', '', '2009-12-17 01:07:48'),
('241', '', 'Macaulay Valenzuela', 'M', '', '1993-07-14', '', '2009-12-17 01:07:48'),
('242', '', 'Laith Lowe', 'M', '', '1976-02-07', '', '2009-12-17 01:07:48'),
('243', '', 'Harper Davis', 'M', '', '1995-12-14', '', '2009-12-17 01:07:48'),
('244', '', 'Steven Mercer', 'M', '', '1975-02-08', '', '2009-12-17 01:07:48'),
('245', '', 'Adrian Gilliam', 'M', '', '1997-10-01', '', '2009-12-17 01:07:48'),
('246', '', 'Devin Duffy', 'M', '', '1982-04-24', '', '2009-12-17 01:07:48'),
('247', '', 'Lev Kaufman', 'M', '', '1978-11-13', '', '2009-12-17 01:07:48'),
('248', '', 'Alvin Benson', 'M', '', '1979-03-06', '', '2009-12-17 01:07:48'),
('249', '', 'Zeph Hunter', 'M', '', '1996-06-11', '', '2009-12-17 01:07:48'),
('250', '', 'Zeus Schwartz', 'M', '', '1977-01-22', '', '2009-12-17 01:07:48'),
('251', '', 'Alfonso Workman', 'M', '', '2003-01-17', '', '2009-12-17 01:07:48'),
('252', '', 'Uriah Lang', 'M', '', '1997-03-19', '', '2009-12-17 01:07:48'),
('253', '', 'Adrian Mclean', 'M', '', '2007-09-20', '', '2009-12-17 01:07:48'),
('254', '', 'Beau Wiggins', 'M', '', '1974-02-03', '', '2009-12-17 01:07:48'),
('255', '', 'Justin Prince', 'M', '', '1971-02-01', '', '2009-12-17 01:07:48'),
('256', '', 'Cedric Cooper', 'M', '', '1987-01-06', '', '2009-12-17 01:07:48'),
('257', '', 'Malachi Rogers', 'M', '', '1984-07-03', '', '2009-12-17 01:07:48'),
('258', '', 'Oscar Boyle', 'M', '', '1986-08-17', '', '2009-12-17 01:07:48'),
('259', '', 'Addison Melton', 'M', '', '1973-06-03', '', '2009-12-17 01:07:48'),
('260', '', 'Neil Baker', 'M', '', '1980-12-15', '', '2009-12-17 01:07:48'),
('261', '', 'Warren Yang', 'M', '', '1998-10-07', '', '2009-12-17 01:07:48'),
('262', '', 'Devin Mcclain', 'M', '', '1994-12-14', '', '2009-12-17 01:07:48'),
('263', '', 'Isaac Garner', 'M', '', '2000-12-06', '', '2009-12-17 01:07:48'),
('264', '', 'Lucius Johnston', 'M', '', '1997-08-28', '', '2009-12-17 01:07:48'),
('265', '', 'Rafael Morin', 'M', '', '2004-01-31', '', '2009-12-17 01:07:48'),
('266', '', 'Driscoll Schmidt', 'M', '', '1975-09-13', '', '2009-12-17 01:07:48'),
('267', '', 'Lionel Deleon', 'M', '', '2004-06-29', '', '2009-12-17 01:07:48'),
('268', '', 'Erich Moss', 'M', '', '1971-01-13', '', '2009-12-17 01:07:48'),
('269', '', 'Salvador Holmes', 'M', '', '1997-12-27', '', '2009-12-17 01:07:48'),
('270', '', 'Leo Harper', 'M', '', '2007-11-24', '', '2009-12-17 01:07:48'),
('271', '', 'Carson Rush', 'M', '', '1993-09-14', '', '2009-12-17 01:07:48'),
('272', '', 'Kibo Sharpe', 'M', '', '1973-12-06', '', '2009-12-17 01:07:48'),
('273', '', 'Kevin Gilbert', 'M', '', '1971-03-03', '', '2009-12-17 01:07:48'),
('274', '', 'Ulysses Mcknight', 'M', '', '1985-10-09', '', '2009-12-17 01:07:48'),
('275', '', 'Walter Moon', 'M', '', '1998-09-30', '', '2009-12-17 01:07:48'),
('276', '', 'Linus Turner', 'M', '', '2007-07-01', '', '2009-12-17 01:07:48'),
('277', '', 'Lewis Vargas', 'M', '', '1997-08-22', '', '2009-12-17 01:07:48'),
('278', '', 'Ivor Bullock', 'M', '', '1980-07-08', '', '2009-12-17 01:07:48'),
('279', '', 'Cyrus Campbell', 'M', '', '2008-02-10', '', '2009-12-17 01:07:48'),
('280', '', 'Kirk Barber', 'M', '', '1977-04-19', '', '2009-12-17 01:07:48'),
('281', '', 'Quentin Tillman', 'M', '', '1972-02-01', '', '2009-12-17 01:07:48'),
('282', '', 'Silas Herring', 'M', '', '1976-12-03', '', '2009-12-17 01:07:48'),
('283', '', 'Brian Cooke', 'M', '', '1989-08-01', '', '2009-12-17 01:07:48'),
('284', '', 'Arsenio William', 'M', '', '2007-12-13', '', '2009-12-17 01:07:48'),
('285', '', 'Lionel Olson', 'M', '', '1981-05-13', '', '2009-12-17 01:07:48'),
('286', '', 'Forrest Sanders', 'M', '', '1974-06-02', '', '2009-12-17 01:07:48'),
('287', '', 'Ishmael Weeks', 'M', '', '1972-12-12', '', '2009-12-17 01:07:48'),
('288', '', 'Lyle Blake', 'M', '', '1992-05-26', '', '2009-12-17 01:07:48'),
('289', '', 'Dolan Mayer', 'M', '', '2007-08-27', '', '2009-12-17 01:07:48'),
('290', '', 'Melvin Donaldson', 'M', '', '1973-06-08', '', '2009-12-17 01:07:48'),
('291', '', 'Clarke Frost', 'M', '', '1993-07-06', '', '2009-12-17 01:07:48'),
('292', '', 'Cadman Shields', 'M', '', '2003-12-05', '', '2009-12-17 01:07:48'),
('293', '', 'Conan Morrow', 'M', '', '2008-12-06', '', '2009-12-17 01:07:48'),
('294', '', 'Wayne Jordan', 'M', '', '1979-05-16', '', '2009-12-17 01:07:48'),
('295', '', 'Quinlan Macias', 'M', '', '1973-03-23', '', '2009-12-17 01:07:48'),
('296', '', 'Jelani Martin', 'M', '', '1997-04-16', '', '2009-12-17 01:07:48'),
('297', '', 'Herman Hahn', 'M', '', '2005-02-08', '', '2009-12-17 01:07:48'),
('298', '', 'Yasir Mccullough', 'M', '', '2002-04-27', '', '2009-12-17 01:07:48'),
('299', '', 'Keegan Bates', 'M', '', '1973-04-01', '', '2009-12-17 01:07:48');

CREATE TABLE `patient_custom_data` (
   `id` int(11) unsigned not null auto_increment,
   `field_id` int(11) unsigned not null,
   `patient_id` int(11) unsigned not null,
   `field_value` varchar(45) not null,
   `ts` timestamp not null default CURRENT_TIMESTAMP,
   PRIMARY KEY (`id`),
   KEY `field_id` (`field_id`),
   KEY `patient_id` (`patient_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1;

-- [Table `patient_custom_data` is empty]

CREATE TABLE `patient_custom_field` (
   `id` int(11) unsigned not null auto_increment,
   `field_name` varchar(45) not null,
   `field_options` varchar(45) not null,
   `field_type_id` int(11) unsigned not null,
   `ts` timestamp not null default CURRENT_TIMESTAMP,
   PRIMARY KEY (`id`),
   KEY `field_type_id` (`field_type_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1;

-- [Table `patient_custom_field` is empty]

CREATE TABLE `privilege` (
   `privilege_id` int(11) unsigned not null auto_increment,
   `privilege` varchar(45) not null,
   `description` varchar(200),
   `ts` timestamp not null default CURRENT_TIMESTAMP,
   PRIMARY KEY (`privilege_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1;

-- [Table `privilege` is empty]

CREATE TABLE `range` (
   `range_id` int(10) unsigned not null auto_increment,
   `range` varchar(45) not null,
   `comments` varchar(200),
   `measure_id` int(11) unsigned not null,
   `range_type` int(11),
   `ts` timestamp not null default CURRENT_TIMESTAMP,
   PRIMARY KEY (`range_id`),
   KEY `measure_id` (`measure_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1;

-- [Table `range` is empty]

CREATE TABLE `referrer` (
   `referrer_id` int(11) unsigned not null,
   `referrer` varchar(45),
   `email` varchar(45),
   `phone` varchar(45),
   `contact` varchar(45),
   `comments` varchar(45),
   `ts` timestamp not null default CURRENT_TIMESTAMP,
   PRIMARY KEY (`referrer_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- [Table `referrer` is empty]

CREATE TABLE `role` (
   `role_id` int(11) unsigned not null auto_increment,
   `role` varchar(45) not null,
   `description` varchar(200),
   `created_by` int(11) unsigned,
   `ts` timestamp not null default CURRENT_TIMESTAMP,
   PRIMARY KEY (`role_id`),
   KEY `created_by` (`created_by`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1;

-- [Table `role` is empty]

CREATE TABLE `role_privilege` (
   `role_id` int(11) unsigned not null,
   `privilege_id` int(11) unsigned not null,
   `assigned_by` int(11) unsigned,
   `ts` timestamp not null default CURRENT_TIMESTAMP,
   KEY `privilege_id` (`privilege_id`),
   KEY `role_id` (`role_id`),
   KEY `assigned_by` (`assigned_by`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- [Table `role_privilege` is empty]

CREATE TABLE `specimen` (
   `specimen_id` int(10) unsigned not null,
   `patient_id` int(11) unsigned not null,
   `specimen_type_id` int(11) unsigned not null,
   `user_id` int(11) unsigned,
   `ts` timestamp not null default CURRENT_TIMESTAMP,
   `status_code_id` int(11) unsigned,
   `referred_to` int(11) unsigned,
   `comments` varchar(450),
   `aux_id` varchar(45),
   `date_collected` date not null,
   `date_recvd` date,
   PRIMARY KEY (`specimen_id`),
   KEY `patient_id` (`patient_id`),
   KEY `specimen_type_id` (`specimen_type_id`),
   KEY `user_id` (`user_id`),
   KEY `status_code_id` (`status_code_id`),
   KEY `referred_to` (`referred_to`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

INSERT INTO `specimen` (`specimen_id`, `patient_id`, `specimen_type_id`, `user_id`, `ts`, `status_code_id`, `referred_to`, `comments`, `aux_id`, `date_collected`, `date_recvd`) VALUES 
('100', '100', '6', '0', '2009-12-17 01:07:48', '1', '0', '', '', '2009-05-22', '2009-05-22'),
('101', '132', '7', '0', '2009-12-17 01:07:48', '1', '0', '', '', '2009-01-10', '2009-01-10'),
('102', '284', '7', '0', '2009-12-17 01:07:48', '1', '0', '', '', '2009-02-01', '2009-02-01'),
('103', '145', '7', '0', '2009-12-17 01:07:48', '1', '0', '', '', '2009-04-20', '2009-04-20'),
('104', '290', '7', '0', '2009-12-17 01:07:48', '1', '0', '', '', '2009-05-16', '2009-05-16'),
('105', '128', '7', '0', '2009-12-17 01:07:48', '1', '0', '', '', '2009-06-22', '2009-06-22'),
('106', '222', '7', '0', '2009-12-17 01:07:48', '0', '0', '', '', '2009-07-22', '2009-07-22'),
('107', '242', '6', '0', '2009-12-17 01:07:48', '1', '0', '', '', '2009-01-26', '2009-01-26'),
('108', '106', '7', '0', '2009-12-17 01:07:48', '1', '0', '', '', '2009-04-11', '2009-04-11'),
('109', '151', '6', '0', '2009-12-17 01:07:48', '1', '0', '', '', '2009-04-12', '2009-04-12'),
('110', '122', '7', '0', '2009-12-17 01:07:48', '1', '0', '', '', '2009-06-19', '2009-06-19'),
('111', '257', '7', '0', '2009-12-17 01:07:48', '0', '0', '', '', '2009-05-29', '2009-05-29'),
('112', '234', '7', '0', '2009-12-17 01:07:48', '1', '0', '', '', '2009-10-28', '2009-10-28'),
('113', '147', '7', '0', '2009-12-17 01:07:48', '1', '0', '', '', '2009-04-27', '2009-04-27'),
('114', '175', '7', '0', '2009-12-17 01:07:48', '1', '0', '', '', '2009-07-07', '2009-07-07'),
('115', '296', '6', '0', '2009-12-17 01:07:48', '1', '0', '', '', '2009-09-08', '2009-09-08'),
('116', '151', '7', '0', '2009-12-17 01:07:48', '1', '0', '', '', '2009-01-25', '2009-01-25'),
('117', '266', '7', '0', '2009-12-17 01:07:48', '1', '0', '', '', '2009-09-04', '2009-09-04'),
('118', '102', '6', '0', '2009-12-17 01:07:48', '1', '0', '', '', '2009-08-16', '2009-08-16'),
('119', '176', '7', '0', '2009-12-17 01:07:48', '1', '0', '', '', '2009-07-14', '2009-07-14'),
('120', '201', '6', '0', '2009-12-17 01:07:48', '1', '0', '', '', '2009-01-31', '2009-01-31'),
('121', '188', '7', '0', '2009-12-17 01:07:48', '1', '0', '', '', '2009-10-29', '2009-10-29'),
('122', '225', '6', '0', '2009-12-17 01:07:48', '1', '0', '', '', '2009-10-07', '2009-10-07'),
('123', '181', '6', '0', '2009-12-17 01:07:48', '0', '0', '', '', '2009-03-10', '2009-03-10'),
('124', '143', '6', '0', '2009-12-17 01:07:48', '0', '0', '', '', '2009-08-04', '2009-08-04'),
('125', '290', '7', '0', '2009-12-17 01:07:48', '1', '0', '', '', '2009-03-02', '2009-03-02'),
('126', '204', '7', '0', '2009-12-17 01:07:48', '0', '0', '', '', '2009-03-01', '2009-03-01'),
('127', '167', '6', '0', '2009-12-17 01:07:48', '1', '0', '', '', '2009-09-28', '2009-09-28'),
('128', '137', '6', '0', '2009-12-17 01:07:48', '1', '0', '', '', '2009-04-22', '2009-04-22'),
('129', '273', '6', '0', '2009-12-17 01:07:48', '1', '0', '', '', '2009-09-16', '2009-09-16'),
('130', '254', '6', '0', '2009-12-17 01:07:48', '1', '0', '', '', '2009-08-30', '2009-08-30'),
('131', '172', '7', '0', '2009-12-17 01:07:48', '1', '0', '', '', '2009-04-29', '2009-04-29'),
('132', '193', '7', '0', '2009-12-17 01:07:48', '1', '0', '', '', '2009-05-04', '2009-05-04'),
('133', '163', '7', '0', '2009-12-17 01:07:48', '1', '0', '', '', '2009-07-02', '2009-07-02'),
('134', '238', '6', '0', '2009-12-17 01:07:48', '1', '0', '', '', '2009-06-21', '2009-06-21'),
('135', '181', '6', '0', '2009-12-17 01:07:48', '1', '0', '', '', '2009-02-17', '2009-02-17'),
('136', '216', '6', '0', '2009-12-17 01:07:48', '1', '0', '', '', '2009-08-16', '2009-08-16'),
('137', '273', '7', '0', '2009-12-17 01:07:48', '1', '0', '', '', '2009-08-04', '2009-08-04'),
('138', '289', '6', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-02-22', '2009-02-22'),
('139', '213', '6', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-03-17', '2009-03-17'),
('140', '276', '7', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-09-07', '2009-09-07'),
('141', '104', '7', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-09-06', '2009-09-06'),
('142', '196', '7', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-03-23', '2009-03-23'),
('143', '114', '6', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-08-12', '2009-08-12'),
('144', '206', '6', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-08-29', '2009-08-29'),
('145', '233', '7', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-07-28', '2009-07-28'),
('146', '172', '7', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-05-15', '2009-05-15'),
('147', '122', '7', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-06-04', '2009-06-04'),
('148', '295', '6', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-05-15', '2009-05-15'),
('149', '137', '7', '0', '2009-12-17 01:07:49', '0', '0', '', '', '2009-09-20', '2009-09-20'),
('150', '259', '7', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-01-18', '2009-01-18'),
('151', '245', '7', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-09-04', '2009-09-04'),
('152', '128', '7', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-06-29', '2009-06-29'),
('153', '152', '7', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-04-16', '2009-04-16'),
('154', '280', '7', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-05-15', '2009-05-15'),
('155', '228', '6', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-02-28', '2009-02-28'),
('156', '223', '6', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-05-16', '2009-05-16'),
('157', '244', '6', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-04-03', '2009-04-03'),
('158', '186', '6', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-06-03', '2009-06-03'),
('159', '269', '6', '0', '2009-12-17 01:07:49', '0', '0', '', '', '2009-08-06', '2009-08-06'),
('160', '114', '7', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-03-14', '2009-03-14'),
('161', '216', '7', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-04-10', '2009-04-10'),
('162', '225', '7', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-08-12', '2009-08-12'),
('163', '188', '7', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-07-04', '2009-07-04'),
('164', '149', '7', '0', '2009-12-17 01:07:49', '0', '0', '', '', '2009-04-05', '2009-04-05'),
('165', '237', '6', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-04-28', '2009-04-28'),
('166', '290', '7', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-03-13', '2009-03-13'),
('167', '104', '6', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-06-26', '2009-06-26'),
('168', '201', '7', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-01-01', '2009-01-01'),
('169', '292', '7', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-05-30', '2009-05-30'),
('170', '204', '6', '0', '2009-12-17 01:07:49', '0', '0', '', '', '2009-10-10', '2009-10-10'),
('171', '209', '6', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-05-18', '2009-05-18'),
('172', '145', '7', '0', '2009-12-17 01:07:49', '0', '0', '', '', '2009-08-25', '2009-08-25'),
('173', '109', '7', '0', '2009-12-17 01:07:49', '0', '0', '', '', '2009-09-07', '2009-09-07'),
('174', '261', '7', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-08-16', '2009-08-16'),
('175', '185', '7', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-07-29', '2009-07-29'),
('176', '134', '6', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-05-12', '2009-05-12'),
('177', '155', '7', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-09-28', '2009-09-28'),
('178', '109', '6', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-01-28', '2009-01-28'),
('179', '119', '6', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-09-26', '2009-09-26'),
('180', '298', '6', '0', '2009-12-17 01:07:49', '0', '0', '', '', '2009-10-21', '2009-10-21'),
('181', '264', '7', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-05-11', '2009-05-11'),
('182', '289', '7', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-06-12', '2009-06-12'),
('183', '169', '7', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-09-24', '2009-09-24'),
('184', '291', '7', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-05-24', '2009-05-24'),
('185', '160', '6', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-10-12', '2009-10-12'),
('186', '187', '6', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-09-21', '2009-09-21'),
('187', '180', '6', '0', '2009-12-17 01:07:49', '0', '0', '', '', '2009-09-15', '2009-09-15'),
('188', '259', '7', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-08-26', '2009-08-26'),
('189', '280', '7', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-10-28', '2009-10-28'),
('190', '176', '6', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-05-15', '2009-05-15'),
('191', '232', '7', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-06-01', '2009-06-01'),
('192', '152', '6', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-03-12', '2009-03-12'),
('193', '293', '7', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-01-26', '2009-01-26'),
('194', '126', '7', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-05-11', '2009-05-11'),
('195', '136', '7', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-10-04', '2009-10-04'),
('196', '193', '6', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-06-04', '2009-06-04'),
('197', '289', '6', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-07-31', '2009-07-31'),
('198', '231', '7', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-09-06', '2009-09-06'),
('199', '247', '6', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-06-05', '2009-06-05'),
('200', '278', '6', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-04-20', '2009-04-20'),
('201', '205', '6', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-02-24', '2009-02-24'),
('202', '293', '7', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-05-04', '2009-05-04'),
('203', '250', '6', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-04-03', '2009-04-03'),
('204', '250', '6', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-10-28', '2009-10-28'),
('205', '181', '6', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-02-13', '2009-02-13'),
('206', '277', '7', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-02-28', '2009-02-28'),
('207', '289', '6', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-01-17', '2009-01-17'),
('208', '113', '7', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-08-07', '2009-08-07'),
('209', '210', '7', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-10-02', '2009-10-02'),
('210', '242', '7', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-06-22', '2009-06-22'),
('211', '129', '6', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-08-28', '2009-08-28'),
('212', '174', '7', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-10-13', '2009-10-13'),
('213', '291', '7', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-08-31', '2009-08-31'),
('214', '110', '7', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-05-05', '2009-05-05'),
('215', '233', '7', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-01-24', '2009-01-24'),
('216', '260', '7', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-08-17', '2009-08-17'),
('217', '205', '7', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-05-28', '2009-05-28'),
('218', '160', '7', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-08-12', '2009-08-12'),
('219', '186', '7', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-08-12', '2009-08-12'),
('220', '196', '6', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-08-27', '2009-08-27'),
('221', '231', '6', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-07-06', '2009-07-06'),
('222', '152', '7', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-09-05', '2009-09-05'),
('223', '155', '6', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-01-18', '2009-01-18'),
('224', '171', '6', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-01-10', '2009-01-10'),
('225', '277', '7', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-10-07', '2009-10-07'),
('226', '229', '7', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-10-05', '2009-10-05'),
('227', '189', '7', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-06-07', '2009-06-07'),
('228', '119', '7', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-08-16', '2009-08-16'),
('229', '268', '6', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-05-03', '2009-05-03'),
('230', '131', '7', '0', '2009-12-17 01:07:49', '1', '0', '', '', '2009-02-10', '2009-02-10'),
('231', '282', '7', '0', '2009-12-17 01:07:50', '1', '0', '', '', '2009-04-01', '2009-04-01'),
('232', '247', '7', '0', '2009-12-17 01:07:50', '1', '0', '', '', '2009-07-24', '2009-07-24'),
('233', '152', '6', '0', '2009-12-17 01:07:50', '1', '0', '', '', '2009-09-08', '2009-09-08'),
('234', '162', '7', '0', '2009-12-17 01:07:50', '1', '0', '', '', '2009-06-21', '2009-06-21'),
('235', '277', '7', '0', '2009-12-17 01:07:50', '1', '0', '', '', '2009-10-02', '2009-10-02'),
('236', '126', '6', '0', '2009-12-17 01:07:50', '1', '0', '', '', '2009-09-10', '2009-09-10'),
('237', '126', '7', '0', '2009-12-17 01:07:50', '1', '0', '', '', '2009-04-04', '2009-04-04'),
('238', '108', '6', '0', '2009-12-17 01:07:50', '1', '0', '', '', '2009-08-11', '2009-08-11'),
('239', '137', '6', '0', '2009-12-17 01:07:50', '1', '0', '', '', '2009-01-14', '2009-01-14'),
('240', '150', '6', '0', '2009-12-17 01:07:50', '1', '0', '', '', '2009-10-23', '2009-10-23'),
('241', '140', '7', '0', '2009-12-17 01:07:50', '1', '0', '', '', '2009-08-06', '2009-08-06'),
('242', '109', '7', '0', '2009-12-17 01:07:50', '1', '0', '', '', '2009-05-31', '2009-05-31'),
('243', '109', '7', '0', '2009-12-17 01:07:50', '0', '0', '', '', '2009-03-27', '2009-03-27'),
('244', '139', '6', '0', '2009-12-17 01:07:50', '1', '0', '', '', '2009-05-29', '2009-05-29'),
('245', '256', '7', '0', '2009-12-17 01:07:50', '1', '0', '', '', '2009-06-09', '2009-06-09'),
('246', '239', '6', '0', '2009-12-17 01:07:50', '1', '0', '', '', '2009-02-18', '2009-02-18'),
('247', '117', '6', '0', '2009-12-17 01:07:50', '1', '0', '', '', '2009-07-19', '2009-07-19'),
('248', '117', '7', '0', '2009-12-17 01:07:50', '1', '0', '', '', '2009-01-31', '2009-01-31'),
('249', '240', '6', '0', '2009-12-17 01:07:50', '1', '0', '', '', '2009-06-20', '2009-06-20'),
('250', '235', '7', '0', '2009-12-17 01:07:50', '1', '0', '', '', '2009-10-17', '2009-10-17'),
('251', '186', '7', '0', '2009-12-17 01:07:50', '1', '0', '', '', '2009-01-23', '2009-01-23'),
('252', '248', '7', '0', '2009-12-17 01:07:50', '0', '0', '', '', '2009-10-16', '2009-10-16'),
('253', '141', '7', '0', '2009-12-17 01:07:50', '1', '0', '', '', '2009-03-17', '2009-03-17'),
('254', '154', '7', '0', '2009-12-17 01:07:50', '1', '0', '', '', '2009-07-21', '2009-07-21'),
('255', '256', '6', '0', '2009-12-17 01:07:50', '0', '0', '', '', '2009-02-07', '2009-02-07'),
('256', '249', '6', '0', '2009-12-17 01:07:50', '1', '0', '', '', '2009-08-19', '2009-08-19'),
('257', '203', '6', '0', '2009-12-17 01:07:50', '1', '0', '', '', '2009-05-12', '2009-05-12'),
('258', '268', '6', '0', '2009-12-17 01:07:50', '1', '0', '', '', '2009-08-17', '2009-08-17'),
('259', '120', '7', '0', '2009-12-17 01:07:50', '1', '0', '', '', '2009-05-03', '2009-05-03'),
('260', '141', '6', '0', '2009-12-17 01:07:50', '1', '0', '', '', '2009-08-16', '2009-08-16'),
('261', '168', '6', '0', '2009-12-17 01:07:50', '1', '0', '', '', '2009-05-21', '2009-05-21'),
('262', '143', '7', '0', '2009-12-17 01:07:50', '1', '0', '', '', '2009-03-01', '2009-03-01'),
('263', '274', '7', '0', '2009-12-17 01:07:50', '1', '0', '', '', '2009-01-05', '2009-01-05'),
('264', '243', '7', '0', '2009-12-17 01:07:50', '1', '0', '', '', '2009-07-12', '2009-07-12'),
('265', '283', '7', '0', '2009-12-17 01:07:50', '1', '0', '', '', '2009-02-23', '2009-02-23'),
('266', '250', '7', '0', '2009-12-17 01:07:50', '1', '0', '', '', '2009-05-18', '2009-05-18'),
('267', '109', '7', '0', '2009-12-17 01:07:50', '1', '0', '', '', '2009-06-14', '2009-06-14'),
('268', '171', '6', '0', '2009-12-17 01:07:50', '1', '0', '', '', '2009-07-12', '2009-07-12'),
('269', '289', '7', '0', '2009-12-17 01:07:50', '1', '0', '', '', '2009-10-05', '2009-10-05'),
('270', '201', '7', '0', '2009-12-17 01:07:50', '0', '0', '', '', '2009-04-14', '2009-04-14'),
('271', '117', '7', '0', '2009-12-17 01:07:50', '1', '0', '', '', '2009-05-18', '2009-05-18'),
('272', '194', '6', '0', '2009-12-17 01:07:50', '1', '0', '', '', '2009-09-02', '2009-09-02'),
('273', '207', '6', '0', '2009-12-17 01:07:50', '1', '0', '', '', '2009-08-30', '2009-08-30'),
('274', '157', '6', '0', '2009-12-17 01:07:50', '0', '0', '', '', '2009-04-21', '2009-04-21'),
('275', '184', '6', '0', '2009-12-17 01:07:50', '1', '0', '', '', '2009-03-27', '2009-03-27'),
('276', '289', '7', '0', '2009-12-17 01:07:50', '1', '0', '', '', '2009-09-14', '2009-09-14'),
('277', '291', '6', '0', '2009-12-17 01:07:50', '1', '0', '', '', '2009-04-23', '2009-04-23'),
('278', '162', '6', '0', '2009-12-17 01:07:50', '0', '0', '', '', '2009-08-14', '2009-08-14'),
('279', '286', '6', '0', '2009-12-17 01:07:50', '1', '0', '', '', '2009-06-18', '2009-06-18'),
('280', '117', '7', '0', '2009-12-17 01:07:50', '1', '0', '', '', '2009-05-23', '2009-05-23'),
('281', '224', '7', '0', '2009-12-17 01:07:50', '1', '0', '', '', '2009-08-28', '2009-08-28'),
('282', '224', '7', '0', '2009-12-17 01:07:50', '0', '0', '', '', '2009-08-18', '2009-08-18'),
('283', '292', '6', '0', '2009-12-17 01:07:50', '1', '0', '', '', '2009-07-29', '2009-07-29'),
('284', '212', '7', '0', '2009-12-17 01:07:50', '1', '0', '', '', '2009-06-08', '2009-06-08'),
('285', '251', '7', '0', '2009-12-17 01:07:50', '1', '0', '', '', '2009-05-11', '2009-05-11'),
('286', '105', '7', '0', '2009-12-17 01:07:50', '1', '0', '', '', '2009-08-20', '2009-08-20'),
('287', '104', '6', '0', '2009-12-17 01:07:50', '1', '0', '', '', '2009-01-13', '2009-01-13'),
('288', '120', '7', '0', '2009-12-17 01:07:50', '1', '0', '', '', '2009-10-14', '2009-10-14'),
('289', '189', '7', '0', '2009-12-17 01:07:50', '1', '0', '', '', '2009-04-04', '2009-04-04'),
('290', '157', '7', '0', '2009-12-17 01:07:50', '1', '0', '', '', '2009-02-04', '2009-02-04'),
('291', '161', '7', '0', '2009-12-17 01:07:50', '1', '0', '', '', '2009-07-23', '2009-07-23'),
('292', '140', '7', '0', '2009-12-17 01:07:50', '1', '0', '', '', '2009-04-07', '2009-04-07'),
('293', '220', '6', '0', '2009-12-17 01:07:50', '1', '0', '', '', '2009-08-29', '2009-08-29'),
('294', '216', '6', '0', '2009-12-17 01:07:50', '1', '0', '', '', '2009-05-20', '2009-05-20'),
('295', '255', '7', '0', '2009-12-17 01:07:50', '1', '0', '', '', '2009-04-03', '2009-04-03'),
('296', '287', '6', '0', '2009-12-17 01:07:50', '1', '0', '', '', '2009-09-25', '2009-09-25'),
('297', '269', '7', '0', '2009-12-17 01:07:50', '0', '0', '', '', '2009-10-12', '2009-10-12'),
('298', '112', '7', '0', '2009-12-17 01:07:50', '1', '0', '', '', '2009-01-07', '2009-01-07'),
('299', '136', '7', '0', '2009-12-17 01:07:50', '1', '0', '', '', '2009-02-16', '2009-02-16'),
('1234', '128', '6', '0', '2009-12-17 08:40:48', '0', '0', 'Urgent	', '1234', '2009-12-17', '2009-12-17'),
('1235', '128', '6', '24', '2009-12-17 08:41:49', '1', '0', 'Urgent			', '1235', '2009-12-17', '2009-12-17'),
('1236', '128', '7', '24', '2009-12-17 08:47:11', '0', '0', '				', '1236', '2009-12-17', '2009-12-17');

CREATE TABLE `specimen_custom_data` (
   `id` int(11) unsigned not null auto_increment,
   `field_id` int(11) unsigned not null,
   `specimen_id` int(10) unsigned not null,
   `field_value` varchar(45) not null,
   `ts` timestamp not null default CURRENT_TIMESTAMP,
   PRIMARY KEY (`id`),
   KEY `field_id` (`field_id`),
   KEY `specimen_id` (`specimen_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1;

-- [Table `specimen_custom_data` is empty]

CREATE TABLE `specimen_custom_field` (
   `id` int(11) unsigned not null auto_increment,
   `field_name` varchar(45) not null,
   `field_options` varchar(45) not null,
   `field_type_id` int(11) unsigned not null,
   `ts` timestamp not null default CURRENT_TIMESTAMP,
   PRIMARY KEY (`id`),
   KEY `field_type_id` (`field_type_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1;

-- [Table `specimen_custom_field` is empty]

CREATE TABLE `specimen_test` (
   `test_type_id` int(11) unsigned not null,
   `specimen_type_id` int(11) unsigned not null,
   `ts` timestamp not null default CURRENT_TIMESTAMP,
   KEY `test_type_id` (`test_type_id`),
   KEY `specimen_type_id` (`specimen_type_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- [Table `specimen_test` is empty]

CREATE TABLE `specimen_type` (
   `specimen_type_id` int(11) unsigned not null auto_increment,
   `name` varchar(45) not null,
   `description` varchar(100),
   `ts` timestamp not null default CURRENT_TIMESTAMP,
   PRIMARY KEY (`specimen_type_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1;

-- [Table `specimen_type` is empty]

CREATE TABLE `status_code` (
   `status_code_id` int(11) unsigned not null,
   `status` varchar(45),
   `ts` timestamp not null default CURRENT_TIMESTAMP,
   PRIMARY KEY (`status_code_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- [Table `status_code` is empty]

CREATE TABLE `test` (
   `test_id` int(10) unsigned not null auto_increment,
   `test_type_id` int(11) unsigned not null,
   `result` varchar(45) not null,
   `comments` varchar(200),
   `user_id` int(11) unsigned,
   `ts` timestamp not null default CURRENT_TIMESTAMP,
   `specimen_id` int(11) unsigned,
   PRIMARY KEY (`test_id`),
   KEY `test_type_id` (`test_type_id`),
   KEY `user_id` (`user_id`),
   KEY `specimen_id` (`specimen_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=244;

INSERT INTO `test` (`test_id`, `test_type_id`, `result`, `comments`, `user_id`, `ts`, `specimen_id`) VALUES 
('1', '10', '655,', '', '0', '2009-12-17 01:07:48', '100'),
('2', '13', '8,', '', '0', '2009-12-17 01:07:48', '101'),
('3', '8', '521,', '', '0', '2009-12-17 01:07:48', '102'),
('4', '13', '8,', '', '0', '2009-12-17 01:07:48', '102'),
('5', '8', '807,', '', '0', '2009-12-17 01:07:48', '103'),
('6', '8', '528,', '', '0', '2009-12-17 01:07:48', '104'),
('7', '8', '948,', '', '0', '2009-12-17 01:07:48', '105'),
('8', '8', '', '', '0', '2009-12-17 01:07:48', '106'),
('9', '7', '682,73,', '', '0', '2009-12-17 01:07:48', '107'),
('10', '13', '9,', '', '0', '2009-12-17 01:07:48', '108'),
('11', '8', '703,', '', '0', '2009-12-17 01:07:48', '108'),
('12', '10', '131,', '', '0', '2009-12-17 01:07:48', '109'),
('13', '13', '7,', '', '0', '2009-12-17 01:07:48', '110'),
('14', '8', '', '', '0', '2009-12-17 01:07:48', '111'),
('15', '8', '478,', '', '0', '2009-12-17 01:07:48', '112'),
('16', '13', '2,', '', '0', '2009-12-17 01:07:48', '112'),
('17', '13', '3,', '', '0', '2009-12-17 01:07:48', '113'),
('18', '13', '8,', '', '0', '2009-12-17 01:07:48', '114'),
('19', '7', '397,30,', '', '0', '2009-12-17 01:07:48', '115'),
('20', '13', '5,', '', '0', '2009-12-17 01:07:48', '116'),
('21', '13', '2,', '', '0', '2009-12-17 01:07:48', '117'),
('22', '10', '294,', '', '0', '2009-12-17 01:07:48', '118'),
('23', '13', '7,', '', '0', '2009-12-17 01:07:48', '119'),
('24', '8', '447,', '', '0', '2009-12-17 01:07:48', '119'),
('25', '10', '86,', '', '0', '2009-12-17 01:07:48', '120'),
('26', '13', '6,', '', '0', '2009-12-17 01:07:48', '121'),
('27', '8', '598,', '', '0', '2009-12-17 01:07:48', '121'),
('28', '10', '18,', '', '0', '2009-12-17 01:07:48', '122'),
('29', '10', '', '', '0', '2009-12-17 01:07:48', '123'),
('30', '10', '', '', '0', '2009-12-17 01:07:48', '124'),
('31', '13', '10,', '', '0', '2009-12-17 01:07:48', '125'),
('32', '8', '93,', '', '0', '2009-12-17 01:07:48', '125'),
('33', '13', '', '', '0', '2009-12-17 01:07:48', '126'),
('34', '7', '457,38,', '', '0', '2009-12-17 01:07:48', '127'),
('35', '10', '527,', '', '0', '2009-12-17 01:07:48', '128'),
('36', '7', '645,18,', '', '0', '2009-12-17 01:07:48', '129'),
('37', '10', '511,', '', '0', '2009-12-17 01:07:48', '130'),
('38', '8', '408,', '', '0', '2009-12-17 01:07:48', '131'),
('39', '13', '6,', '', '0', '2009-12-17 01:07:48', '131'),
('40', '13', '10,', '', '0', '2009-12-17 01:07:48', '132'),
('41', '13', '7,', '', '0', '2009-12-17 01:07:48', '133'),
('42', '7', '794,5,', '', '0', '2009-12-17 01:07:48', '134'),
('43', '7', '699,1,', '', '0', '2009-12-17 01:07:48', '135'),
('44', '10', '707,', '', '0', '2009-12-17 01:07:48', '135'),
('45', '7', '928,65,', '', '0', '2009-12-17 01:07:48', '136'),
('46', '8', '398,', '', '0', '2009-12-17 01:07:48', '137'),
('47', '13', '4,', '', '0', '2009-12-17 01:07:49', '137'),
('48', '10', '905,', '', '0', '2009-12-17 01:07:49', '138'),
('49', '7', '387,12,', '', '0', '2009-12-17 01:07:49', '139'),
('50', '13', '2,', '', '0', '2009-12-17 01:07:49', '140'),
('51', '8', '324,', '', '0', '2009-12-17 01:07:49', '141'),
('52', '8', '219,', '', '0', '2009-12-17 01:07:49', '142'),
('53', '10', '363,', '', '0', '2009-12-17 01:07:49', '143'),
('54', '7', '415,22,', '', '0', '2009-12-17 01:07:49', '143'),
('55', '10', '9,', '', '0', '2009-12-17 01:07:49', '144'),
('56', '8', '685,', '', '0', '2009-12-17 01:07:49', '145'),
('57', '13', '3,', '', '0', '2009-12-17 01:07:49', '146'),
('58', '13', '5,', '', '0', '2009-12-17 01:07:49', '147'),
('59', '10', '432,', '', '0', '2009-12-17 01:07:49', '148'),
('60', '13', '', '', '0', '2009-12-17 01:07:49', '149'),
('61', '13', '2,', '', '0', '2009-12-17 01:07:49', '150'),
('62', '8', '282,', '', '0', '2009-12-17 01:07:49', '150'),
('63', '13', '2,', '', '0', '2009-12-17 01:07:49', '151'),
('64', '8', '863,', '', '0', '2009-12-17 01:07:49', '152'),
('65', '13', '3,', '', '0', '2009-12-17 01:07:49', '153'),
('66', '13', '9,', '', '0', '2009-12-17 01:07:49', '154'),
('67', '10', '403,', '', '0', '2009-12-17 01:07:49', '155'),
('68', '10', '170,', '', '0', '2009-12-17 01:07:49', '156'),
('69', '7', '799,35,', '', '0', '2009-12-17 01:07:49', '157'),
('70', '7', '872,29,', '', '0', '2009-12-17 01:07:49', '158'),
('71', '7', '', '', '0', '2009-12-17 01:07:49', '159'),
('72', '13', '9,', '', '0', '2009-12-17 01:07:49', '160'),
('73', '13', '3,', '', '0', '2009-12-17 01:07:49', '161'),
('74', '8', '804,', '', '0', '2009-12-17 01:07:49', '162'),
('75', '13', '2,', '', '0', '2009-12-17 01:07:49', '163'),
('76', '13', '', '', '0', '2009-12-17 01:07:49', '164'),
('77', '10', '171,', '', '0', '2009-12-17 01:07:49', '165'),
('78', '8', '285,', '', '0', '2009-12-17 01:07:49', '166'),
('79', '10', '207,', '', '0', '2009-12-17 01:07:49', '167'),
('80', '7', '355,11,', '', '0', '2009-12-17 01:07:49', '167'),
('81', '8', '686,', '', '0', '2009-12-17 01:07:49', '168'),
('82', '13', '6,', '', '0', '2009-12-17 01:07:49', '169'),
('83', '8', '507,', '', '0', '2009-12-17 01:07:49', '169'),
('84', '7', '', '', '0', '2009-12-17 01:07:49', '170'),
('85', '7', '551,19,', '', '0', '2009-12-17 01:07:49', '171'),
('86', '10', '312,', '', '0', '2009-12-17 01:07:49', '171'),
('87', '13', '', '', '0', '2009-12-17 01:07:49', '172'),
('88', '8', '', '', '0', '2009-12-17 01:07:49', '173'),
('89', '8', '798,', '', '0', '2009-12-17 01:07:49', '174'),
('90', '13', '5,', '', '0', '2009-12-17 01:07:49', '174'),
('91', '8', '547,', '', '0', '2009-12-17 01:07:49', '175'),
('92', '10', '967,', '', '0', '2009-12-17 01:07:49', '176'),
('93', '13', '5,', '', '0', '2009-12-17 01:07:49', '177'),
('94', '10', '270,', '', '0', '2009-12-17 01:07:49', '178'),
('95', '10', '210,', '', '0', '2009-12-17 01:07:49', '179'),
('96', '10', '', '', '0', '2009-12-17 01:07:49', '180'),
('97', '8', '213,', '', '0', '2009-12-17 01:07:49', '181'),
('98', '8', '36,', '', '0', '2009-12-17 01:07:49', '182'),
('99', '13', '8,', '', '0', '2009-12-17 01:07:49', '183'),
('100', '8', '160,', '', '0', '2009-12-17 01:07:49', '184'),
('101', '10', '323,', '', '0', '2009-12-17 01:07:49', '185'),
('102', '7', '551,49,', '', '0', '2009-12-17 01:07:49', '185'),
('103', '7', '502,67,', '', '0', '2009-12-17 01:07:49', '186'),
('104', '7', '', '', '0', '2009-12-17 01:07:49', '187'),
('105', '8', '878,', '', '0', '2009-12-17 01:07:49', '188'),
('106', '13', '4,', '', '0', '2009-12-17 01:07:49', '189'),
('107', '10', '614,', '', '0', '2009-12-17 01:07:49', '190'),
('108', '8', '546,', '', '0', '2009-12-17 01:07:49', '191'),
('109', '7', '266,8,', '', '0', '2009-12-17 01:07:49', '192'),
('110', '10', '54,', '', '0', '2009-12-17 01:07:49', '192'),
('111', '13', '4,', '', '0', '2009-12-17 01:07:49', '193'),
('112', '8', '99,', '', '0', '2009-12-17 01:07:49', '194'),
('113', '13', '1,', '', '0', '2009-12-17 01:07:49', '195'),
('114', '7', '986,22,', '', '0', '2009-12-17 01:07:49', '196'),
('115', '10', '614,', '', '0', '2009-12-17 01:07:49', '197'),
('116', '13', '8,', '', '0', '2009-12-17 01:07:49', '198'),
('117', '7', '35,68,', '', '0', '2009-12-17 01:07:49', '199'),
('118', '10', '46,', '', '0', '2009-12-17 01:07:49', '199'),
('119', '10', '653,', '', '0', '2009-12-17 01:07:49', '200'),
('120', '7', '550,55,', '', '0', '2009-12-17 01:07:49', '201'),
('121', '13', '7,', '', '0', '2009-12-17 01:07:49', '202'),
('122', '7', '135,8,', '', '0', '2009-12-17 01:07:49', '203'),
('123', '7', '695,15,', '', '0', '2009-12-17 01:07:49', '204'),
('124', '10', '789,', '', '0', '2009-12-17 01:07:49', '204'),
('125', '10', '899,', '', '0', '2009-12-17 01:07:49', '205'),
('126', '13', '1,', '', '0', '2009-12-17 01:07:49', '206'),
('127', '7', '842,3,', '', '0', '2009-12-17 01:07:49', '207'),
('128', '10', '219,', '', '0', '2009-12-17 01:07:49', '207'),
('129', '8', '833,', '', '0', '2009-12-17 01:07:49', '208'),
('130', '13', '2,', '', '0', '2009-12-17 01:07:49', '208'),
('131', '8', '923,', '', '0', '2009-12-17 01:07:49', '209'),
('132', '8', '453,', '', '0', '2009-12-17 01:07:49', '210'),
('133', '13', '10,', '', '0', '2009-12-17 01:07:49', '210'),
('134', '7', '774,35,', '', '0', '2009-12-17 01:07:49', '211'),
('135', '13', '8,', '', '0', '2009-12-17 01:07:49', '212'),
('136', '8', '324,', '', '0', '2009-12-17 01:07:49', '213'),
('137', '8', '125,', '', '0', '2009-12-17 01:07:49', '214'),
('138', '13', '6,', '', '0', '2009-12-17 01:07:49', '214'),
('139', '8', '983,', '', '0', '2009-12-17 01:07:49', '215'),
('140', '8', '294,', '', '0', '2009-12-17 01:07:49', '216'),
('141', '13', '6,', '', '0', '2009-12-17 01:07:49', '216'),
('142', '13', '5,', '', '0', '2009-12-17 01:07:49', '217'),
('143', '8', '684,', '', '0', '2009-12-17 01:07:49', '217'),
('144', '13', '4,', '', '0', '2009-12-17 01:07:49', '218'),
('145', '8', '877,', '', '0', '2009-12-17 01:07:49', '219'),
('146', '10', '805,', '', '0', '2009-12-17 01:07:49', '220'),
('147', '10', '566,', '', '0', '2009-12-17 01:07:49', '221'),
('148', '13', '3,', '', '0', '2009-12-17 01:07:49', '222'),
('149', '8', '382,', '', '0', '2009-12-17 01:07:49', '222'),
('150', '7', '536,11,', '', '0', '2009-12-17 01:07:49', '223'),
('151', '10', '956,', '', '0', '2009-12-17 01:07:49', '224'),
('152', '13', '9,', '', '0', '2009-12-17 01:07:49', '225'),
('153', '8', '483,', '', '0', '2009-12-17 01:07:49', '226'),
('154', '13', '7,', '', '0', '2009-12-17 01:07:49', '227'),
('155', '8', '143,', '', '0', '2009-12-17 01:07:49', '227'),
('156', '8', '812,', '', '0', '2009-12-17 01:07:49', '228'),
('157', '10', '610,', '', '0', '2009-12-17 01:07:49', '229'),
('158', '7', '742,66,', '', '0', '2009-12-17 01:07:49', '229'),
('159', '13', '1,', '', '0', '2009-12-17 01:07:49', '230'),
('160', '13', '3,', '', '0', '2009-12-17 01:07:50', '231'),
('161', '8', '974,', '', '0', '2009-12-17 01:07:50', '231'),
('162', '8', '254,', '', '0', '2009-12-17 01:07:50', '232'),
('163', '7', '830,48,', '', '0', '2009-12-17 01:07:50', '233'),
('164', '8', '907,', '', '0', '2009-12-17 01:07:50', '234'),
('165', '13', '7,', '', '0', '2009-12-17 01:07:50', '235'),
('166', '10', '563,', '', '0', '2009-12-17 01:07:50', '236'),
('167', '13', '10,', '', '0', '2009-12-17 01:07:50', '237'),
('168', '10', '776,', '', '0', '2009-12-17 01:07:50', '238'),
('169', '10', '457,', '', '0', '2009-12-17 01:07:50', '239'),
('170', '10', '290,', '', '0', '2009-12-17 01:07:50', '240'),
('171', '13', '10,', '', '0', '2009-12-17 01:07:50', '241'),
('172', '8', '129,', '', '0', '2009-12-17 01:07:50', '242'),
('173', '13', '', '', '0', '2009-12-17 01:07:50', '243'),
('174', '8', '', '', '0', '2009-12-17 01:07:50', '243'),
('175', '7', '120,58,', '', '0', '2009-12-17 01:07:50', '244'),
('176', '13', '10,', '', '0', '2009-12-17 01:07:50', '245'),
('177', '10', '543,', '', '0', '2009-12-17 01:07:50', '246'),
('178', '7', '551,31,', '', '0', '2009-12-17 01:07:50', '247'),
('179', '8', '605,', '', '0', '2009-12-17 01:07:50', '248'),
('180', '10', '576,', '', '0', '2009-12-17 01:07:50', '249'),
('181', '13', '3,', '', '0', '2009-12-17 01:07:50', '250'),
('182', '8', '651,', '', '0', '2009-12-17 01:07:50', '251'),
('183', '13', '', '', '0', '2009-12-17 01:07:50', '252'),
('184', '8', '652,', '', '0', '2009-12-17 01:07:50', '253'),
('185', '8', '510,', '', '0', '2009-12-17 01:07:50', '254'),
('186', '7', '', '', '0', '2009-12-17 01:07:50', '255'),
('187', '10', '848,', '', '0', '2009-12-17 01:07:50', '256'),
('188', '10', '788,', '', '0', '2009-12-17 01:07:50', '257'),
('189', '10', '767,', '', '0', '2009-12-17 01:07:50', '258'),
('190', '13', '10,', '', '0', '2009-12-17 01:07:50', '259'),
('191', '10', '774,', '', '0', '2009-12-17 01:07:50', '260'),
('192', '7', '342,72,', '', '0', '2009-12-17 01:07:50', '261'),
('193', '8', '364,', '', '0', '2009-12-17 01:07:50', '262'),
('194', '8', '431,', '', '0', '2009-12-17 01:07:50', '263'),
('195', '13', '9,', '', '0', '2009-12-17 01:07:50', '264'),
('196', '8', '559,', '', '0', '2009-12-17 01:07:50', '265'),
('197', '8', '671,', '', '0', '2009-12-17 01:07:50', '266'),
('198', '13', '5,', '', '0', '2009-12-17 01:07:50', '267'),
('199', '7', '377,71,', '', '0', '2009-12-17 01:07:50', '268'),
('200', '8', '739,', '', '0', '2009-12-17 01:07:50', '269'),
('201', '13', '2,', '', '0', '2009-12-17 01:07:50', '269'),
('202', '8', '', '', '0', '2009-12-17 01:07:50', '270'),
('203', '13', '8,', '', '0', '2009-12-17 01:07:50', '271'),
('204', '10', '559,', '', '0', '2009-12-17 01:07:50', '272'),
('205', '7', '50,50,', '', '24', '2009-12-17 01:07:50', '273'),
('206', '10', '50,', '', '24', '2009-12-17 01:07:50', '273'),
('207', '7', '', '', '0', '2009-12-17 01:07:50', '274'),
('208', '10', '', '', '0', '2009-12-17 01:07:50', '274'),
('209', '10', '241,', '', '0', '2009-12-17 01:07:50', '275'),
('210', '13', '8,', '', '0', '2009-12-17 01:07:50', '276'),
('211', '7', '546,40,', '', '0', '2009-12-17 01:07:50', '277'),
('212', '7', '', '', '0', '2009-12-17 01:07:50', '278'),
('213', '10', '', '', '0', '2009-12-17 01:07:50', '278'),
('214', '7', '506,46,', '', '0', '2009-12-17 01:07:50', '279'),
('215', '8', '103,', '', '0', '2009-12-17 01:07:50', '280'),
('216', '13', '7,', '', '0', '2009-12-17 01:07:50', '281'),
('217', '8', '', '', '0', '2009-12-17 01:07:50', '282'),
('218', '10', '937,', '', '0', '2009-12-17 01:07:50', '283'),
('219', '13', '4,', '', '0', '2009-12-17 01:07:50', '284'),
('220', '8', '499,', '', '0', '2009-12-17 01:07:50', '284'),
('221', '13', '6,', '', '0', '2009-12-17 01:07:50', '285'),
('222', '13', '7,', '', '0', '2009-12-17 01:07:50', '286'),
('223', '8', '443,', '', '0', '2009-12-17 01:07:50', '286'),
('224', '7', '284,7,', '', '0', '2009-12-17 01:07:50', '287'),
('225', '8', '790,', '', '0', '2009-12-17 01:07:50', '288'),
('226', '8', '660,', '', '0', '2009-12-17 01:07:50', '289'),
('227', '8', '877,', '', '0', '2009-12-17 01:07:50', '290'),
('228', '8', '140,', '', '0', '2009-12-17 01:07:50', '291'),
('229', '13', '2,', '', '0', '2009-12-17 01:07:50', '291'),
('230', '13', '3,', '', '0', '2009-12-17 01:07:50', '292'),
('231', '7', '106,78,', '', '0', '2009-12-17 01:07:50', '293'),
('232', '10', '984,', '', '0', '2009-12-17 01:07:50', '294'),
('233', '13', '2,', '', '0', '2009-12-17 01:07:50', '295'),
('234', '7', '231,56,', '', '0', '2009-12-17 01:07:50', '296'),
('235', '8', '', '', '0', '2009-12-17 01:07:50', '297'),
('236', '13', '6,', '', '0', '2009-12-17 01:07:50', '298'),
('237', '8', '665,', '', '0', '2009-12-17 01:07:50', '299'),
('238', '7', '', '', '24', '2009-12-17 08:40:48', '1234'),
('239', '10', '', '', '24', '2009-12-17 08:40:48', '1234'),
('240', '7', '60,60,', 'Low value range', '24', '2009-12-17 08:41:49', '1235'),
('241', '10', '90,', '', '24', '2009-12-17 08:41:49', '1235'),
('242', '8', '', '', '24', '2009-12-17 08:47:11', '1236'),
('243', '13', '', '', '24', '2009-12-17 08:47:11', '1236');

CREATE TABLE `test_category` (
   `test_category_id` int(11) unsigned not null auto_increment,
   `name` varchar(45) not null,
   `description` varchar(100),
   `ts` timestamp not null default CURRENT_TIMESTAMP,
   PRIMARY KEY (`test_category_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1;

-- [Table `test_category` is empty]

CREATE TABLE `test_type` (
   `test_type_id` int(11) unsigned not null auto_increment,
   `name` varchar(45) not null,
   `description` varchar(100),
   `test_category_id` int(11) unsigned not null,
   `ts` timestamp not null default CURRENT_TIMESTAMP,
   PRIMARY KEY (`test_type_id`),
   KEY `test_category_id` (`test_category_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1;

-- [Table `test_type` is empty]

CREATE TABLE `test_type_measure` (
   `test_type_id` int(11) unsigned not null,
   `measure_id` int(11) unsigned not null,
   `ts` timestamp not null default CURRENT_TIMESTAMP,
   KEY `test_type_id` (`test_type_id`),
   KEY `measure_id` (`measure_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- [Table `test_type_measure` is empty]

CREATE TABLE `unit` (
   `unit_id` int(11) unsigned not null auto_increment,
   `unit` varchar(45) not null,
   `ts` timestamp not null default CURRENT_TIMESTAMP,
   PRIMARY KEY (`unit_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1;

-- [Table `unit` is empty]

CREATE TABLE `user` (
   `user_id` int(11) unsigned not null auto_increment,
   `username` varchar(45) not null,
   `password` varchar(45) not null,
   `actualname` varchar(45),
   `email` varchar(45),
   `created_by` int(11) unsigned,
   `ts` timestamp not null default CURRENT_TIMESTAMP,
   `lab_config_id` int(10) unsigned,
   `level` int(10) unsigned,
   PRIMARY KEY (`user_id`),
   KEY `user_id_index` (`lab_config_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1;

-- [Table `user` is empty]

CREATE TABLE `user_role` (
   `user_id` int(11) unsigned not null,
   `role_id` int(11) unsigned not null,
   `assigned_by` int(11) unsigned,
   `ts` timestamp not null default CURRENT_TIMESTAMP,
   KEY `role_id` (`role_id`),
   KEY `assigned_by` (`assigned_by`),
   KEY `user_id` (`user_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- [Table `user_role` is empty]